	INCLUDE EFR32MG12.inc		; CPU register definitions
	EXPORT	main
	IMPORT	GPIO_setup		; import names from other code files	

RGB_LED0	EQU	0		; defines for 4 RGB leds on board
RGB_LED1	EQU	1
RGB_LED2	EQU	2
RGB_LED3	EQU	3	
RED_LED		EQU	11		; RGB LED control pins at PD
GREEN_LED	EQU	12
BLUE_LED	EQU	13
	
;-------------------------------------	; CODE segment in flash (ROM)
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	GPIO_setup

	OORW	1<<RGB_LED1, GPIO_PI_DOUT, GPIO ; enable RGB_LED 1
loop
	mov	R0, #1<<RED_LED
	bl	toggleLED		; toggle red LED
	mov	R0, #1<<GREEN_LED
	bl	toggleLED		; toggle green LED
	mov	R0, #1<<BLUE_LED
	bl	toggleLED		; toggle blue LED	
	b	loop			; loop back		
	ENDP

;--------------------------------------
toggleLED	PROC			; R0 = led to toggle
	push	{LR, R0-R2}		; save used regs
	ldr	R1, =GPIO
	mov	R2, #GPIO_PD_DOUT
	str	R0, [R1, R2]		; turn LED on
	bl 	delay
	orn	R0, #-1			; negate R0
	str	R0, [R1, R2]		; turn LED 0ff
	bl	delay		
	pop	{PC, R0-R2}
	ENDP

;--------------------------------------
delay	PROC				; software delay for about 1 sec
	push	{R0}
	ldr 	R0, =5000000
dl	subs	R0, #1
	bne	dl
	pop	{R0}
	bx	LR
	ENDP

	ALIGN
	END
	